package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.SysHospitalDTO;
import com.diagbot.dto.SysHospitalDeptInfoDTO;
import com.diagbot.dto.SysSetInfoDTO;
import com.diagbot.entity.HospitalInfo;
import com.diagbot.entity.SysSet;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.SysSetServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.IntegerUtil;
import com.diagbot.vo.HospitalSetVO;
import com.diagbot.vo.SysHospitalCodeVO;
import com.diagbot.vo.SysHospitalInfoVO;
import com.google.common.collect.Lists;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author wangfeng
 * @Description: TODO
 * @date 2019年6月12日 下午3:25:36
 */
@Component
public class SysSetFacade extends SysSetServiceImpl {


    /**
     * @param hospitalSetVO
     * @return
     */
    public List<SysSetInfoDTO> getSysSetInfoData(HospitalSetVO hospitalSetVO) {

        if (IntegerUtil.isNull(hospitalSetVO.getPlan())) {
            hospitalSetVO.setPlan(0);
        }
        List<SysSet> sysSetData = querySysSetInfo(hospitalSetVO);
        List<SysSetInfoDTO> data = BeanUtil.listCopyTo(sysSetData, SysSetInfoDTO.class);
        return data;
    }

    /**
     * @param sysHospitalCodeVO
     * @return
     */
    public SysHospitalDTO getHospitalDeptInfoData(SysHospitalCodeVO sysHospitalCodeVO) {
        //取出下级医院Code
        QueryWrapper<SysSet> sysSetInfo = new QueryWrapper<>();
        sysSetInfo.eq("is_deleted", IsDeleteEnum.N.getKey());
        sysSetInfo.eq("hospital_code", sysHospitalCodeVO.getHospitalCode());
        sysSetInfo.eq("code", sysHospitalCodeVO.getJuniorHospitalCode());
        sysSetInfo.eq("sys_type", sysHospitalCodeVO.getSysType());
        SysSet sysSetInfoData = getOne(sysSetInfo, false);
        SysHospitalInfoVO sysHospitalInfoVO = new SysHospitalInfoVO();
        List<String> listCode = Lists.newArrayList(sysSetInfoData.getValue().split(","));
        //追加集团code
        listCode.add(sysHospitalCodeVO.getHospitalCode());
        //查询下级医院的默认科室
        sysHospitalInfoVO.setHospitalCode(listCode);
        sysHospitalInfoVO.setCode(sysHospitalCodeVO.getDefaultDeptCode());
        sysHospitalInfoVO.setSysType(sysHospitalCodeVO.getSysType());
        List<SysHospitalDeptInfoDTO> juniorHospitalData = getjuniorHospitalData(sysHospitalInfoVO);
        SysHospitalDTO sysHospitalDTO = new SysHospitalDTO();
        List<SysHospitalDeptInfoDTO> hospitalDatas = new ArrayList<SysHospitalDeptInfoDTO>();
        for (SysHospitalDeptInfoDTO superiorsInfoData : juniorHospitalData) {
            if (superiorsInfoData.getHospitalCode().equals(sysHospitalCodeVO.getHospitalCode())) {
                //取出顶级集团信息
                sysHospitalDTO.setSuperiorsInfo(superiorsInfoData);
            } else {
                //下级医院信息
                hospitalDatas.add(superiorsInfoData);
            }
        }
        sysHospitalDTO.setJuniorHospital(hospitalDatas);
        return sysHospitalDTO;
    }
}
